Index: palm/trunk/INSTALL/example_cbl_rc
===================================================================
--- palm/trunk/INSTALL/example_cbl_rc	(revision 1105)
+++ palm/trunk/INSTALL/example_cbl_rc	(revision 1106)
@@ -1,11 +1,11 @@
 
- ***************************         ------------------------------------------
- * PALM 3.9  Rev: 1096     *         atmosphere - 3D - run without 1D - prerun
- ***************************         ------------------------------------------
-
- Date:              03-02-13         Run:       example_cbl         
- Time:              04:25:21         Run-No.:   00
- Run on host:         lcsgih
- Number of PEs:            8         Processor grid (x,y): (  2,  4) calculated
+ ******************************      ------------------------------------------
+ * PALM 3.9  Rev: 1106        *      atmosphere - 3D - run without 1D - prerun
+ ******************************      ------------------------------------------
+
+ Date:                 04-03-13      Run:       example_cbl         
+ Time:                 06:06:34      Run-No.:   00
+ Run on host:            lcsgih
+ Number of PEs:               8      Processor grid (x,y): (  2,  4) calculated
  ------------------------------------------------------------------------------
 
@@ -25,7 +25,7 @@
  ----------------------------------
 
- Timestep:          variable     maximum value: 20.000 s    CFL-factor: 0.90
- Start time:           0.000 s
- End time:          3600.000 s
+ Timestep:             variable     maximum value: 20.000 s    CFL-factor: 0.90
+ Start time:              0.000 s
+ End time:             3600.000 s
 
 
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 1105)
+++ palm/trunk/SCRIPTS/mrun	(revision 1106)
@@ -22,5 +22,6 @@
 # Current revisions:
 # ------------------
-# 
+# --stdin argument for mpiexec on lckyuh
+# -y and -Y settings output to header
 #
 # Former revisions:
@@ -2029,5 +2030,10 @@
  if [[ -n $numprocs ]]
  then
-    spalte1="number of PEs:"; spalte2=$numprocs
+    if [[ $run_coupled_model = false ]]
+    then
+       spalte1="number of PEs:"; spalte2=$numprocs
+    else
+       spalte1="number of PEs:"; spalte2="$numprocs  (atmosphere: $numprocs_atmos, ocean: $numprocs_ocean)"
+    fi
     printf "| %-25s%-45s | \n" "$spalte1" "$spalte2"
  fi
@@ -2126,4 +2132,9 @@
  spalte1="OUTPUT control list:"; spalte2=$(echo $output_list)
  printf "| %-25s%-45s | \n" "$spalte1" "$spalte2"
+
+ if [[ "$ocean_file_appendix" = true ]]
+ then
+    printf "| %-35s%-35s | \n" "suffix \"_O\" is added to local files" " "
+ fi
 
  if [[ $do_batch = true  ||  "$LOADLBATCH" = yes ]]
@@ -3650,7 +3661,7 @@
                 elif [[ $host = lckyu* ]]
                 then
-                   mpiexec -n $ii  ./a.out  < runfile_atmos  $ROPTS
+                   mpiexec -n $ii --stdin runfile_atmos  ./a.out  $ROPTS
                 else
-                   mpiexec  -machinefile hostfile  -n $ii  a.out  < runfile_atmos  $ROPTS
+                   mpiexec  -machinefile hostfile  -n $ii  a.out  <  runfile_atmos  $ROPTS
                 fi
              else
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1105)
+++ palm/trunk/SOURCE/Makefile	(revision 1106)
@@ -20,4 +20,5 @@
 # Current revisions:
 # ------------------
+# +cuda_fft_interfaces
 #
 # Former revisions:
@@ -116,5 +117,6 @@
 	calc_radiation.f90 calc_spectra.f90 check_for_restart.f90 \
 	check_open.f90 check_parameters.f90 close_file.f90 compute_vpt.f90 \
-	coriolis.f90 cpu_log.f90 cpu_statistics.f90 data_log.f90 \
+	coriolis.f90 cpu_log.f90 cpu_statistics.f90 cuda_fft_interfaces.f90 \
+	data_log.f90 \
 	data_output_dvrp.f90 data_output_mask.f90 data_output_profiles.f90 \
 	data_output_ptseries.f90 data_output_spectra.f90 \
@@ -140,6 +142,6 @@
 	lpm_set_attributes.f90 lpm_sort_arrays.f90 \
 	lpm_write_exchange_statistics.f90 lpm_write_restart_file.f90 \
-	message.f90 modules.f90 netcdf.f90 package_parin.f90 palm.f90 \
-	parin.f90 plant_canopy_model.f90 poisfft.f90 \
+	message.f90 microphysics.f90 modules.f90 netcdf.f90 package_parin.f90 \
+	palm.f90 parin.f90 plant_canopy_model.f90 poisfft.f90 \
 	poisfft_hybrid.f90 poismg.f90 prandtl_fluxes.f90 pres.f90 print_1d.f90 \
 	production_e.f90 prognostic_equations.f90 random_function.f90 \
@@ -161,6 +163,5 @@
 	user_parin.f90 user_read_restart_data.f90 \
 	user_spectra.f90 user_statistics.f90 wall_fluxes.f90 \
-	write_3d_binary.f90 write_compressed.f90 write_var_list.f90 \
-	microphysics.f90
+	write_3d_binary.f90 write_compressed.f90 write_var_list.f90
 
 OBJS =  advec_s_bc.o advec_s_pw.o advec_s_up.o advec_u_pw.o advec_u_up.o \
@@ -170,5 +171,5 @@
 	calc_spectra.o check_for_restart.o check_open.o check_parameters.o \
 	close_file.o compute_vpt.o coriolis.o cpu_log.o cpu_statistics.o \
-	data_log.o data_output_dvrp.o data_output_mask.o \
+	cuda_fft_interfaces.o data_log.o data_output_dvrp.o data_output_mask.o \
 	data_output_profiles.o data_output_ptseries.o \
 	data_output_spectra.o data_output_tseries.o data_output_2d.o \
@@ -190,6 +191,6 @@
 	lpm_pack_arrays.o lpm_read_restart_file.o lpm_release_set.o \
 	lpm_set_attributes.o lpm_sort_arrays.o lpm_write_exchange_statistics.o \
-	lpm_write_restart_file.o message.o modules.o netcdf.o package_parin.o \
-	palm.o parin.o plant_canopy_model.o poisfft.o \
+	lpm_write_restart_file.o message.o microphysics.o modules.o netcdf.o \
+	package_parin.o palm.o parin.o plant_canopy_model.o poisfft.o \
 	poisfft_hybrid.o poismg.o prandtl_fluxes.o pres.o print_1d.o \
 	production_e.o prognostic_equations.o random_function.o random_gauss.o \
@@ -208,6 +209,5 @@
 	user_lpm_init.o user_lpm_set_attributes.o user_module.o user_parin.o \
 	user_read_restart_data.o user_spectra.o user_statistics.o \
-	wall_fluxes.o write_3d_binary.o write_compressed.o write_var_list.o \
-	microphysics.o
+	wall_fluxes.o write_3d_binary.o write_compressed.o write_var_list.o
 
 CC = cc
@@ -264,4 +264,5 @@
 cpu_log.o: modules.o
 cpu_statistics.o: modules.o
+cuda_fft_interfaces.o: cuda_fft_interfaces.f90
 data_log.o: modules.o
 data_output_dvrp.o: modules.o
@@ -284,5 +285,5 @@
 exchange_horiz.o: modules.o
 exchange_horiz_2d.o: modules.o
-fft_xy.o: modules.o singleton.o temperton_fft.o
+fft_xy.o: cuda_fft_interfaces.o modules.o singleton.o temperton_fft.o
 flow_statistics.o: modules.o
 global_min_max.o: modules.o
@@ -330,4 +331,5 @@
 lpm_write_restart_file.o: modules.o
 message.o: modules.o
+microphysics.o: modules.o
 modules.o: modules.f90
 netcdf.o: modules.o
@@ -399,3 +401,2 @@
 write_compressed.o: modules.o
 write_var_list.o: modules.o
-microphysics.o: modules.o
Index: palm/trunk/SOURCE/Makefile_check
===================================================================
--- palm/trunk/SOURCE/Makefile_check	(revision 1105)
+++ palm/trunk/SOURCE/Makefile_check	(revision 1106)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-#
+# +cuda_fft_interfaces
 #
 # Former revisions:
@@ -56,10 +56,10 @@
 
 RCS = check_open.f90 check_namelist_files.f90 check_parameters.f90 \
-      close_file.f90 cpu_log.f90 exchange_horiz.f90 exchange_horiz_2d.f90 \
-      fft_xy.f90 init_grid.f90 init_masks.f90 init_cloud_physics.f90 \
-      init_pegrid.f90 local_flush.f90 local_stop.f90 local_system.f90 \
-      message.f90 modules.f90 package_parin.f90 parin.f90 poisfft.f90 \
-      poisfft_hybrid.f90 random_function.f90 singleton.f90 subsidence.f90 \
-      temperton_fft.f90 \
+      close_file.f90 cpu_log.f90 cuda_fft_interfaces.f90 exchange_horiz.f90 \
+      exchange_horiz_2d.f90 fft_xy.f90 init_grid.f90 init_masks.f90 \
+      init_cloud_physics.f90 init_pegrid.f90 local_flush.f90 local_stop.f90 \
+      local_system.f90 message.f90 modules.f90 package_parin.f90 parin.f90 \
+      poisfft.f90 poisfft_hybrid.f90 random_function.f90 singleton.f90 \
+      subsidence.f90 temperton_fft.f90 \
       user_3d_data_averaging.f90 user_actions.f90 \
       user_additional_routines.f90 user_check_data_output.f90 \
@@ -78,18 +78,18 @@
 
 OBJS = check_open.o check_namelist_files.o check_parameters.o close_file.o \
-      cpu_log.o exchange_horiz.o exchange_horiz_2d.o fft_xy.o init_grid.o \
-      init_masks.o init_pegrid.o init_cloud_physics.o\
-      local_flush.o local_stop.o local_system.o message.o \
-      modules.o package_parin.o parin.o poisfft.o \
-      poisfft_hybrid.o random_function.o singleton.o subsidence.o temperton_fft.o \
-      user_3d_data_averaging.o user_actions.o user_additional_routines.o \
-      user_check_data_output.o user_check_data_output_pr.o \
-      user_check_parameters.o user_data_output_2d.o user_data_output_3d.o \
-      user_data_output_mask.o user_data_output_dvrp.o \
-      user_define_netcdf_grid.o user_dvrp_coltab.o user_header.o \
-      user_init.o user_init_3d_model.o user_init_grid.o \
-      user_init_plant_canopy.o user_last_actions.o user_lpm_advec.o \
-      user_lpm_init.o user_lpm_set_attributes.o user_module.o user_parin.o \
-      user_read_restart_data.o user_spectra.o user_statistics.o \
+       cpu_log.o cuda_fft_interfaces.o exchange_horiz.o exchange_horiz_2d.o \
+       fft_xy.o init_grid.o init_masks.o init_pegrid.o init_cloud_physics.o\
+       local_flush.o local_stop.o local_system.o message.o \
+       modules.o package_parin.o parin.o poisfft.o \
+       poisfft_hybrid.o random_function.o singleton.o subsidence.o temperton_fft.o \
+       user_3d_data_averaging.o user_actions.o user_additional_routines.o \
+       user_check_data_output.o user_check_data_output_pr.o \
+       user_check_parameters.o user_data_output_2d.o user_data_output_3d.o \
+       user_data_output_mask.o user_data_output_dvrp.o \
+       user_define_netcdf_grid.o user_dvrp_coltab.o user_header.o \
+       user_init.o user_init_3d_model.o user_init_grid.o \
+       user_init_plant_canopy.o user_last_actions.o user_lpm_advec.o \
+       user_lpm_init.o user_lpm_set_attributes.o user_module.o user_parin.o \
+       user_read_restart_data.o user_spectra.o user_statistics.o \
 
 CC = cc
@@ -124,7 +124,8 @@
 close_file.o: modules.o
 cpu_log.o: modules.o
+cuda_fft_interfaces.o: cuda_fft_interfaces.f90
 exchange_horiz.o: modules.o
 exchange_horiz_2d.o: modules.o
-fft_xy.o: modules.o singleton.o temperton_fft.o
+fft_xy.o: cuda_fft_interfaces.o modules.o singleton.o temperton_fft.o
 init_cloud_physics.o: modules.o
 init_grid.o: modules.o
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 1105)
+++ palm/trunk/SOURCE/check_open.f90	(revision 1106)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! array_kind renamed precision_kind
 !
 ! Former revisions:
@@ -109,5 +109,4 @@
 !------------------------------------------------------------------------------!
 
-    USE array_kind
     USE arrays_3d
     USE control_parameters
@@ -117,4 +116,5 @@
     USE particle_attributes
     USE pegrid
+    USE precision_kind
     USE profil_parameter
     USE statistics
Index: palm/trunk/SOURCE/cuda_fft_interfaces.f90
===================================================================
--- palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 1106)
+++ palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 1106)
@@ -0,0 +1,111 @@
+ MODULE cuda_fft_interfaces
+
+!--------------------------------------------------------------------------------!
+! This file is part of PALM.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms
+! of the GNU General Public License as published by the Free Software Foundation,
+! either version 3 of the License, or (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2012  Leibniz University Hannover
+!--------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+!
+! Description:
+! ------------
+! FORTRAN interfaces for the CUDA fft
+! Routines for the fft along x and y (forward/backward) using the CUDA fft
+!--------------------------------------------------------------------------------!
+
+#if defined ( __cuda_fft )
+
+    INTEGER :: CUFFT_FORWARD = -1,  &
+               CUFFT_INVERSE =  1,  &
+               CUFFT_R2C = Z'2a',   &    ! Real to Complex (interleaved)
+               CUFFT_C2R = Z'2c',   &    ! Complex (interleaved) to Real
+               CUFFT_C2C = Z'29',   &    ! Complex to Complex, interleaved
+               CUFFT_D2Z = Z'6a',   &    ! Double to Double-Complex
+               CUFFT_Z2D = Z'6c',   &    ! Double-Complex to Double
+               CUFFT_Z2Z = Z'69'         ! Double-Complex to Double-Complex
+
+    PUBLIC
+
+
+!
+!-- cufftPlan1d( cufftHandle *plan, int nx, cufftType type, int batch )
+    INTERFACE CUFFTPLAN1D
+
+       SUBROUTINE CUFFTPLAN1D( plan, nx, type, batch ) bind( C, name='cufftPlan1d' )
+
+          USE ISO_C_BINDING
+
+          INTEGER(C_INT) ::  plan
+          INTEGER(C_INT), value ::  batch, nx, type
+
+       END SUBROUTINE CUFFTPLAN1D
+
+    END INTERFACE CUFFTPLAN1D
+
+!
+!-- cufftDestroy( cufftHandle plan )  !!! remove later if not really needed !!!
+    INTERFACE CUFFTDESTROY
+
+       SUBROUTINE CUFFTDESTROY( plan ) bind( C, name='cufftDestroy' )
+
+          USE ISO_C_BINDING
+
+          INTEGER(C_INT), value ::  plan
+
+       END SUBROUTINE CUFFTDESTROY
+
+    END INTERFACE CUFFTDESTROY
+
+
+    INTERFACE CUFFTEXECZ2D
+
+       SUBROUTINE CUFFTEXECZ2D( plan, idata, odata ) bind( C, name='cufftExecZ2D' )
+
+          USE ISO_C_BINDING
+          USE precision_kind
+
+          INTEGER(C_INT), value ::  plan
+          COMPLEX(dpk), device  ::  idata(*)
+          REAL(dpk), device     ::  odata(*)
+
+       END SUBROUTINE CUFFTEXECZ2D
+
+    END INTERFACE CUFFTEXECZ2D
+
+
+    INTERFACE CUFFTEXECD2Z
+
+       SUBROUTINE CUFFTEXECD2Z( plan, idata, odata ) bind( C, name='cufftExecD2Z' )
+
+          USE ISO_C_BINDING
+          USE precision_kind
+
+          INTEGER(C_INT), value ::  plan
+          REAL(dpk), device     ::  idata(*)
+          COMPLEX(dpk), device  ::  odata(*)
+
+       END SUBROUTINE CUFFTEXECD2Z
+
+    END INTERFACE CUFFTEXECD2Z
+
+#endif
+ END MODULE cuda_fft_interfaces
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1105)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1106)
@@ -19,5 +19,6 @@
 !
 ! Current revisions:
-! -----------------
+! ------------------
+! array_kind renamed precision_kind
 !
 ! Former revisions:
@@ -105,5 +106,4 @@
 !------------------------------------------------------------------------------!
 
-    USE array_kind
     USE arrays_3d
     USE averaging
@@ -116,4 +116,5 @@
     USE particle_attributes
     USE pegrid
+    USE precision_kind
 
     IMPLICIT NONE
Index: palm/trunk/SOURCE/data_output_profiles.f90
===================================================================
--- palm/trunk/SOURCE/data_output_profiles.f90	(revision 1105)
+++ palm/trunk/SOURCE/data_output_profiles.f90	(revision 1106)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! bugfix: initial time for preruns of coupled runs is output as -coupling_start_time
 !
 ! Former revisions:
@@ -126,11 +126,13 @@
 #if defined( __netcdf )          
 !
-!--             Store initial time (t=0) to time axis, but only if an output
-!--             is required for at least one of the profiles
+!--             Store initial time to time axis, but only if an output
+!--             is required for at least one of the profiles. The initial time
+!--             is either 0, or, in case of a prerun for coupled atmosphere-ocean
+!--             runs, has a negative value
                 DO  i = 1, dopr_n
                 IF ( dopr_initial_index(i) /= 0 )  THEN
                    nc_stat = NF90_PUT_VAR( id_set_pr, id_var_time_pr,  &
-                                              (/ 0.0 /), start = (/ 1 /), &
-                                              count = (/ 1 /) )
+                                           (/ -coupling_start_time /), &
+                                           start = (/ 1 /), count = (/ 1 /) )
                       CALL handle_netcdf_error( 'data_output_profiles', 329 )
                       output_for_t0 = .TRUE.
